stages:
  - build
  - test
  - deploy
  - revert

variables:
  docker_html_path: "/www"
  env: prod
  deploy_subfolder: html



install_dependencies:
  image: node:14.15.0-stretch
  stage: build
  script:
    - yarn install
    - yarn build
    - mv build build_$env
  artifacts:
    paths:
      - node_modules
      - build_$env
  cache:
    key:
      files:
        - yarn.lock
    paths:
      - node_modules

build_staging:
  extends: install_dependencies
  variables:
    env: staging
    REACT_APP_WEBSITE_PREFIX: "[staging] [branch=$CI_COMMIT_BRANCH] "
    PUBLIC_URL: "/$CI_COMMIT_BRANCH"

deploy_staging:
  extends: deploy_prod
  variables:
    deploy_subfolder: staging/$CI_COMMIT_BRANCH
    env: staging
  when: always
  only:
    - main
    - /feature-.*/

deploy_prod:
  stage: deploy
  script:
    - cp -r build_$env $docker_html_path/test-app/${env}_$CI_COMMIT_SHA
    - cp -Pv $docker_html_path/$deploy_subfolder $docker_html_path/test-app/${env}_$CI_COMMIT_SHA/prev-version || true
  only:
    - main

activate_staging:
  extends: activate_prod
  variables:
    deploy_subfolder: staging/$CI_COMMIT_BRANCH
    env: staging
  when: always
  only:
    - main
    - /feature-.*/

activate_prod:
  stage: deploy
  script:
    - ln -fsnv /var/www/test-app/${env}_$CI_COMMIT_SHA $docker_html_path/$deploy_subfolder
  when: manual
  only:
    - main




revert:
  stage: revert
  when: manual
  script:
    - cp -Pv --remove-destination $docker_html_path/test-app/$CI_COMMIT_SHA/prev-version $docker_html_path/html


